## libxpertmass 1.7.1

=== CMakeLists.txt ===
# ##############################################################################
# ##############################################################################
# CMake configuration 3.18.4 in oldstable as of 2024 - 07 - 15
cmake_minimum_required(VERSION 3.18.4)

set(CMAKE_PROJECT_INCLUDE_BEFORE ${CMAKE_SOURCE_DIR}/CMakeStuff/ancillary-project-include-before.cmake)

# ##############################################################################
# ##############################################################################
# Basic information about project

project(
    XpertMass
    VERSION 1.7.1
    DESCRIPTION "Libraries [XpertMass::Core (non-GUI) and XpertMass::Gui) for the MsXpertSuite project."
    HOMEPAGE_URL "http://wwww.msxpertsuite.org/libxpertmass"
    LANGUAGES CXX
)

set(LOWCASE_PROJECT_NAME xpertmass)

# project(VERSION) above sets: PROJECT_VERSION, <PROJECT-NAME>_VERSION
# PROJECT_VERSION_MAJOR, <PROJECT-NAME>_VERSION_MAJOR PROJECT_VERSION_MINOR,
# <PROJECT-NAME>_VERSION_MINOR PROJECT_VERSION_PATCH,
# <PROJECT-NAME>_VERSION_PATCH

message("\n${BoldGreen}Building version ${PROJECT_VERSION} of \
${PROJECT_NAME} (${CMAKE_PROJECT_DESCRIPTION})${ColourReset}\n"
)

# Set additional project information
set(COMPANY "MsXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2025 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite.libxpertmass")

# This line MUST be located prior to include'ing GNUInstallDirs !!!
#############################################################
#############################################################
# Installation prefix
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX
        "/usr/local"
        CACHE PATH "Install path" FORCE
    )
else()
    set(CMAKE_INSTALL_PREFIX
        "${CMAKE_INSTALL_PREFIX}"
        CACHE PATH "Install path" FORCE
    )
    message(STATUS "Setting CMAKE_INSTALL_PREFIX to ${CMAKE_INSTALL_PREFIX}")
endif()

include(GNUInstallDirs)
include(FeatureSummary)

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)

# Our build scripts take for granted that this files is available.
configure_file(${CMAKE_UTILS_PATH}/version.cmake.in ${CMAKE_BINARY_DIR}/version.txt)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldYellow}The devel directory where all the development projects \
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n"
)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldGreen}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by the Clang-based code
# analyzer.
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json")
    execute_process(
        COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
                ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()

# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}")
message(STATUS "CMAKE_CXX_STANDARD_REQUIRED: ${CMAKE_CXX_STANDARD_REQUIRED}")

message(STATUS "CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}")

# ##############################################################################
# Setting command line compiler definitions:
message(STATUS "${BoldYellow}Setting compiler command line definitions.${ColourReset}")

# We do not want warnings for unknown pragmas:
message("Setting definition -Wno-unknown-pragmas.")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message("Setting definition -Wall -pedantic.")
add_definitions(-Wall -pedantic)
message("Setting definition -Wextra.")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
    message("Setting definition -Werror.")
    add_definitions(-Werror)
else()
    message("NOT setting definition -Werror.")
endif()

message(STATUS "\nCMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}\n")

option(MXE "Use the cross-compiling environment MXE" OFF)

option(PAPPSO_LOCAL_DEV "Use locally developped libpappsomspp" OFF)
option(PAPPSO_LOCAL_INST "Use /usr/local/lib installed libpappsomspp" OFF)

if(PAPPSO_LOCAL_DEV AND PAPPSO_LOCAL_INST)
    message(FATAL_ERROR "Cannot have both PAPPSO_LOCAL_DEV and PAPPSO_LOCAL_INST")
endif()

message(STATUS "PAPPSO_LOCAL_DEV: ${PAPPSO_LOCAL_DEV}")
message(STATUS "PAPPSO_LOCAL_INST: ${PAPPSO_LOCAL_INST}")

# ##############################################################################
# ##############################################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

    if(MXE)

        # Run the following cmake command line: x86_64-w64-mingw32.shared-cmake
        # -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
        include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

        # Set the name to the systemUname variable because in this situation that
        # name is not found, it it passed as a flag in the command line.
        set(SYSTEM_UNAME_S "mxe")

    elseif(WIN10UCRT64)
        include(${CMAKE_TOOLCHAINS_PATH}/win10-ucrt64-toolchain.cmake)
    endif()

elseif(UNIX)

    message("UNIX toolchain being selected")

    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-common.cmake)

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")

# ##############################################################################
# ##############################################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE
        Release
        CACHE STRING "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel." FORCE
    )
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    message(STATUS "Compiling in release mode.")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
    message(STATUS "Compiling in debug mode.")
    message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
    add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    message(STATUS "Compiling in release with debug info mode.")
endif(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")

option(PROFILING Off)
if(PROFILING)
    message(STATUS "${BoldYellow}Profiling is requested, adding -pg -g flags.${ColourReset}")
    add_definitions(-pg -g)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# ##############################################################################
# ##############################################################################
# BUILD OF THE LIBRARIES

message(STATUS "\n${BoldGreen}Adding subdirectory src for PROJECT: \
${CMAKE_PROJECT_NAME}${ColourReset}\n"
)
add_subdirectory(source)

# ##############################################################################
# ##############################################################################
# BUILD THE DOCUMENTATION (JavaScript reference and/or devdoc)
add_subdirectory(doc)

# ##############################################################################
# ##############################################################################
# BUILD OF THE TESTS
option(BUILD_TESTS Off)
option(CODE_COVERAGE "Collect coverage for tests " Off)

if(UNIX AND CODE_COVERAGE)
    set(BUILD_TESTS On)
endif()

if(UNIX AND BUILD_TESTS)

    if(CMAKE_COMPILER_IS_GNUCXX AND CODE_COVERAGE)
        set(CMAKE_BUILD_TYPE Debug)
        include(CodeCoverage)
        append_coverage_compiler_flags()
    endif()

    message(STATUS "\n${BoldGreen}Build the tests ${ColourReset}\n")
    message("Adding subdirectory tests for PROJECT: ${CMAKE_PROJECT_NAME}")

    add_subdirectory(tests)

endif()

# ##############################################################################
# ##############################################################################
# PROFILING
option(PROFILING Off)
if(PROFILING)
    message("Add profiling flag -pg")
    add_compile_options("-pg")
endif()

# ##############################################################################
# ##############################################################################
# Creation of the source archive
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

set(PARENT_DIR ${CMAKE_SOURCE_DIR}/..)
set(TARBALL_DIR ${PARENT_DIR}/tarballs)

add_custom_target(
    archive
    cpack
    -G
    TGZ
    --config
    CPackSourceConfig.cmake
    &&
    mv
    ${CMAKE_BINARY_DIR}/${ARCHIVE_FILE_NAME_EXT}
    ${TARBALL_DIR}
    &&
    ln
    -sf
    ${TARBALL_DIR}/${ARCHIVE_FILE_NAME_EXT}
    ${PARENT_DIR}/${DEBIAN_ORIG_FILE_NAME}
    &&
    ln
    -sf
    ${TARBALL_DIR}/${ARCHIVE_FILE_NAME_EXT}
    ${TARBALL_DIR}/${DEBIAN_ORIG_FILE_NAME}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating .tar.gz"
    VERBATIM
)

# -----------------------------------------------------------#
# Summary
# -----------------------------------------------------------#
message("\n\nBegin feature summary")
message("---------------------\n")
feature_summary(FATAL_ON_MISSING_REQUIRED_PACKAGES WHAT ALL)
message("---------------------")
message("End feature summary\n\n")

=== tests/CMakeLists.txt ===
message("\n${BoldGreen}Now configuring tests for ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message("To make the tests and then perform the coverage analysis:")
message("cmake ../../development -DBUILD_TESTS=On -DCODE_COVERAGE=On -DCMAKE_BUILD_TYPE=Debug")
message("make")
message("make coverage")
message("And the coverage results will be output (HTML) in ${CMAKE_CURRENT_BINARY_DIR}/coverage")

# This export will allow using the flags to be used by the Clang-based code
# analyzer.
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json")
    execute_process(
        COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
                ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()

# This file is included if BUILD_TESTS option is set to ON

configure_file(${CMAKE_UTILS_PATH}/tests-config.h.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/tests-config.h @ONLY)

find_package(Catch2 3 REQUIRED)

# Whatever the platform, this always works.
find_package(
    Qt6 REQUIRED
    COMPONENTS Core
               Svg
               Xml
               Network
               Qml
)

message("Using the local XPERTMASS tree libraries and includes to build the tests")
message("")

set(XpertMass_FOUND 1)
set(XpertMass_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/source/XpertMassCore/includes")
set(XpertMass_LIBRARIES "${CMAKE_BINARY_DIR}/source/XpertMassCore/libXpertMassCore.so")

if(NOT TARGET XpertMass::Core)

    add_library(XpertMass::Core UNKNOWN IMPORTED GLOBAL)
    set_target_properties(
        XpertMass::Core PROPERTIES IMPORTED_LOCATION ${XpertMass_LIBRARIES} INTERFACE_INCLUDE_DIRECTORIES
                                                                            ${XpertMass_INCLUDE_DIRS}
    )

endif()

message("")

set(tests_SRCS
    catch2-test-main.cpp
    TestUtils.cpp
    test_CalcOptions.cpp
    test_Isotope.cpp
    test_IsotopicData.cpp
    test_IsotopicDataLibraryHandler.cpp
    test_IsotopicDataUserConfigHandler.cpp
    test_IsotopicDataManualConfigHandler.cpp
    test_Formula.cpp
    test_Ionizer.cpp
    test_ChemicalGroupRule.cpp
    test_ChemicalGroup.cpp
    test_IndexRange.cpp
    test_IndexRangeCollection.cpp
    test_Modif.cpp
    test_Monomer.cpp
    test_Sequence.cpp
    test_CrossLinker.cpp
    test_CrossLinkedRegion.cpp
    test_CrossLink.cpp
    test_CleavageAgent.cpp
    test_CleavageMotif.cpp
    test_CleavageRule.cpp
    test_CleavageConfig.cpp
    test_FragmentationRule.cpp
    test_FragmentationPathway.cpp
    test_FragmentationConfig.cpp
    test_PolChemDef.cpp
    test_PolChemDefSpec.cpp
    test_Polymer.cpp
    test_Oligomer.cpp
    test_Cleaver.cpp
    test_Fragmenter.cpp
    test_MassCollection.cpp
)

add_executable(
    testRunner
    ${tests_SRCS} ${${TARGET}_QRC_CPP}
)

# We set the target link libraries this way to reuse them later.
set(TARGET_LINK_LIBRARIES
    -Wl,--whole-archive
    XpertMass::Core
    -Wl,--no-whole-archive
    -Wl,--no-as-needed
    PappsoMSpp::Core
    -Wl,--as-needed
    IsoSpec++::IsoSpec++
    Qt6::Core
    Qt6::Xml
    Qt6::Network
    Qt6::Qml
    Catch2::Catch2WithMain
)

# Finally actually set the linking dependencies to the executable.
target_link_libraries(
    testRunner ${TARGET_LINK_LIBRARIES}
)

# For the tests-config.h file
target_include_directories(
    testRunner
    PUBLIC ${CMAKE_CURRENT_BINARY_DIR}
)

set_property(TARGET testRunner PROPERTY CXX_STANDARD 17) # we want C++17
add_dependencies(testRunner XpertMass::Core)

# Enable testing
# enable_testing()

include(Catch)
catch_discover_tests(testRunner)

# Add the Catch2-based single binary test file to the CMake's test suite so that
# it gets called using 'make test'. To see the output, add "ARGS=-V" to the
# call.

add_test(NAME CoreTests COMMAND testRunner)

# add_custom_target(runtests ALL
add_custom_target(
    runtests
    COMMAND testRunner --success
    DEPENDS testRunner XpertMass::Core
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Now running the tests"
)

set(core_includes_dir "${CMAKE_SOURCE_DIR}/source/XpertMassCore/includes/MsXpS/libXpertMassCore")
# message("core_includes_dir: ${core_includes_dir}")
set(gui_includes_dir "${CMAKE_SOURCE_DIR}/source/XpertMassGui/includes/MsXpS/libXpertMassGui/")
# message("gui_includes_dir: ${gui_includes_dir}")

set(tests_dir ${CMAKE_CURRENT_LIST_DIR})

if(CMAKE_COMPILER_IS_GNUCXX AND CODE_COVERAGE)

    file(GLOB CORE_HEADER_FILES "${core_includes_dir}/*.hpp" "${core_includes_dir}/*.h")
    # message("CORE_HEADER_FILES: ${CORE_HEADER_FILES}")

    file(GLOB GUI_HEADER_FILES "${gui_includes_dir}/*.hpp" "${Cgui_includes_dir}/*.h")
    # message("GUI_HEADER_FILES: ${GUI_HEADER_FILES}")

    file(GLOB TEST_SOURCE_FILES "${tests_dir}/*.cpp")

    set(COVERAGE_EXCLUDES ${CORE_HEADER_FILES} ${GUI_HEADER_FILES} ${TEST_SOURCE_FILES})

    message("COVERAGE_EXCLUDES: ${COVERAGE_EXCLUDES}")

    include(CodeCoverage)

    append_coverage_compiler_flags()
    # Added to change the theme, by looking into the code
    set(GCOVR_ADDITIONAL_ARGS ${GCOVR_ADDITIONAL_ARGS} --html-theme github.blue)
    # Added to ouput the gcovr command to the terminal, by looking into the code
    set(CODE_COVERAGE_VERBOSE On)
    setup_target_for_coverage_gcovr_html(
        NAME
        code_coverage
        EXECUTABLE
        ${CMAKE_CURRENT_BINARY_DIR}/testRunner
        ||
        /dev/true
        BASE_DIRECTORY
        ${CMAKE_SOURCE_DIR}
    )

    add_dependencies(code_coverage testRunner XpertMass::Core)
endif()

=== source/XpertMassCore/CMakeLists.txt ===
#set(CMAKE_C_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)
#set(CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)

# Not sure we actually need this for the analyzer?
if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json")
    execute_process(
        COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
                ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()

message("\n${BoldGreen}Now configuring library libXpertMassCore${ColourReset}\n")

# ##############################################################################
# Files
set(XpertMassCore_SRCS
    #
    # Most general features
    src/globals.cpp
    src/Utils.cpp
    src/Prop.cpp
    src/PropListHolder.cpp
    #
    # The basic chemical features
    src/Isotope.cpp
    src/IsotopicData.cpp
    src/IsotopicDataBaseHandler.cpp
    src/IsotopicDataLibraryHandler.cpp
    src/IsotopicDataUserConfigHandler.cpp
    src/IsotopicDataManualConfigHandler.cpp
    #
    src/ChemicalGroupRule.cpp
    src/ChemicalGroup.cpp
    src/PkaPhPi.cpp
    src/PkaPhPiDataParser.cpp
    #
    src/Formula.cpp
    src/Ionizer.cpp
    src/Modif.cpp
    src/Monomer.cpp
    src/MonomerDictionary.cpp
    #
    src/CrossLinker.cpp
    src/CrossLink.cpp
    src/CrossLinkedRegion.cpp
    #
    src/MassCollection.cpp
    #
    # Calculation engine configuration
    src/CalcOptions.cpp
    #
    # The mass peak shaping feature
    src/MassPeakShaper.cpp
    src/MassPeakShaperConfig.cpp
    src/IsotopicClusterShaper.cpp
    src/IsotopicClusterGenerator.cpp
    #
    # The chemical reactions
    src/CleavageMotif.cpp
    src/CleavageRule.cpp
    src/CleavageAgent.cpp
    src/CleavageConfig.cpp
    src/Cleaver.cpp
    src/FragmentationRule.cpp
    src/FragmentationConfig.cpp
    src/FragmentationPathway.cpp
    src/Fragmenter.cpp
    #
    # Polymer chemistry definition
    src/PolChemDefSpec.cpp
    src/PolChemDef.cpp
    #
    # Sequence entities
    src/IndexRange.cpp
    src/IndexRangeCollection.cpp
    src/Sequence.cpp
    src/Polymer.cpp
    src/Oligomer.cpp
    src/OligomerPair.cpp
    src/OligomerCollection.cpp
    #
    # The network functionality
    src/MassDataCborBaseHandler.cpp
    src/MassDataCborMassSpectrumHandler.cpp
    src/MassDataServer.cpp
    src/MassDataClient.cpp
    #
    # Recent files handler
    src/RecentFilesHandler.cpp
    #
    # Tolerance
    src/Tolerance.cpp
    #
    # Scripting-related
    src/XpertMassCoreJavaScript.cpp
    src/jsclassregistrar.cpp
)

qt6_add_resources(XpertMassCore_QRC_CPP xpertmasscore_resources.qrc)

# This is only a workaround to the fact that although we list *.hpp and *.cpp
# files as source files for the add_target() command, and although we
# have the Q_NAMESPACE in the Enums namespace, the moc_globals.cpp file is
# not added to the image files linked into the library).
# This has as a bad effect of having not the Enums staticMetaObject in the
# library, which then translates into an undefined symbol linker error.
qt6_wrap_cpp(Core_MOC_SOURCES includes/MsXpS/libXpertMassCore/globals.hpp)

# Because the header files are in their own directory and not along the source
# files, we need to have them listed explicitely for automoc to work properly
# below.

# Create a variable to hold the 'includes' directory *relative* to the current
# CMakeLists.txt file.

set(INCLUDES_DIR "${CMAKE_CURRENT_LIST_DIR}/includes")
file(GLOB_RECURSE XpertMassCore_HEADERS ${INCLUDES_DIR}/*.h ${INCLUDES_DIR}/*.hpp)
message(STATUS "Included the header files from ${INCLUDES_DIR}: \n\
  ${XpertMassCore_HEADERS}"
)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Sure we need this ? add_library(compiler_flags INTERFACE)
# target_compile_features(compiler_flags INTERFACE cxx_std_11)

if(CMAKE_COMPILER_IS_GNUCXX AND CODE_COVERAGE)
    include(CodeCoverage)
    append_coverage_compiler_flags()
endif()

# ##############################################################################
# Configuration of the binary to be built
# ##############################################################################

# Only now can we add the library, because we have defined the sources.

# ##############################################################################
# Build the static lib
add_library(
    Core_static STATIC
    ${XpertMassCore_HEADERS}
    ${XpertMassCore_SRCS}
    ${Core_MOC_SOURCES} # See explanation above about globals.cpp Enums
    ${XpertMassCore_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
)

# So that the JavaScript reference text is extracted before using
# xpertmasscore_resources.qrc that reference it.
add_dependencies(Core_static extract_class_js_ref_text)

set_target_properties(
    Core_static
    PROPERTIES # Set target properties for namespace
               EXPORT_NAME "Core_static"
               OUTPUT_NAME XpertMassCore
               LINK_FLAGS "-Wl,--whole-archive"
)

target_link_libraries(
    Core_static
    PUBLIC PappsoMSpp::Core
           IsoSpec++::IsoSpec++
           Qt6::Core
           Qt6::Svg
           Qt6::Xml
           Qt6::Network
           Qt6::Qml
)

if(PROFILING)
    target_link_options(Core_static PRIVATE -pg)
endif()

# The install interface that is ${prefix}/include.

target_include_directories(
    Core_static
    PUBLIC # These include directories are for building of this lib.
           $<BUILD_INTERFACE:${INCLUDES_DIR}>
           # These include directories are for users of this lib.
           $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

get_target_property(Core_static_INCLUDES Core_static INCLUDE_DIRECTORIES)
message(STATUS "Core_static_INCLUDES: ${Core_static_INCLUDES}")

install(
    TARGETS Core_static
    EXPORT XpertMassCoreStaticTargets.cmake
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    INCLUDES
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

# Export static targets
install(
    EXPORT XpertMassCoreStaticTargets.cmake
    FILE XpertMassCoreStaticTargets.cmake
    NAMESPACE XpertMass::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass
)

export(
    EXPORT XpertMassCoreStaticTargets.cmake
    FILE "${CMAKE_CURRENT_BINARY_DIR}/XpertMassCoreStaticTargets.cmake"
    NAMESPACE XpertMass::
)

# ##############################################################################
# Build the shared lib
add_library(
    Core SHARED
    ${XpertMassCore_HEADERS}
    ${XpertMassCore_SRCS}
    ${Core_MOC_SOURCES} # See explanation above about globals.cpp Enums
    ${XpertMassCore_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
)

set_target_properties(
    Core
    PROPERTIES # Set target properties for namespace
               EXPORT_NAME "Core"
               # The actual shared library name: libXpertMass
               OUTPUT_NAME XpertMassCore
               VERSION ${PROJECT_VERSION}
               SOVERSION ${PROJECT_VERSION_MAJOR}
               LINK_FLAGS "-Wl,--no-as-needed"
               POSITION_INDEPENDENT_CODE ON
)

# So that the JavaScript reference text is extracted before using
# xpertmasscore_resources.qrc that reference it.
add_dependencies(Core extract_class_js_ref_text)

target_link_libraries(
    Core
    PUBLIC PappsoMSpp::Core
           IsoSpec++::IsoSpec++
           Qt6::Core
           Qt6::Xml
           Qt6::Network
           Qt6::Qml
)

if(PROFILING)
    target_link_options(Core PRIVATE -pg)
endif()

# The INSTALL_INTERFACE that is ${prefix}/include

target_include_directories(
    Core
    PUBLIC # These include directories are for building of this lib.
           $<BUILD_INTERFACE:${INCLUDES_DIR}>
           # These include directories are for users of this lib.
           $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

get_target_property(Core_INCLUDES Core INCLUDE_DIRECTORIES)
message(STATUS "Core_INCLUDES: ${Core_INCLUDES}")

target_compile_definitions(Core PRIVATE "EXPORT_LIB_SYMBOLS")

# This is to avoid the "include_next(math.h) file not found" error.
if(WIN32)
    set_target_properties(Core_static PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)
    set_target_properties(Core PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)
endif()

install(
    TARGETS Core
    EXPORT XpertMassCoreSharedTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    INCLUDES
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

# Export shared targets
install(
    EXPORT XpertMassCoreSharedTargets
    FILE XpertMassCoreSharedTargets.cmake
    NAMESPACE XpertMass::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass
)

export(
    EXPORT XpertMassCoreSharedTargets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/XpertMassCoreSharedTargets.cmake"
    NAMESPACE XpertMass::
)

# ##############################################################################
# Common installation configuration

message("The directory containing the includes: ${CMAKE_CURRENT_LIST_DIR}/includes/MsXpS/libXpertMassCore")

install(
    DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/includes/MsXpS/libXpertMassCore
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/MsXpS"
)
install(
    FILES ${CMAKE_CURRENT_LIST_DIR}/includes/MsXpS/export-import-config.h
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/MsXpS"
)

message("")
message(STATUS "CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}")
message("")
message(STATUS "${BoldGreen}Finished configuration of libXpertMass.${ColourReset}")
message("")

message("\n${BoldGreen}Done configuring library libXpertMassCore${ColourReset}\n")

=== source/XpertMassGui/CMakeLists.txt ===
# set(CMAKE_C_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)
# set(CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)

# Not sure we actually need this for the analyzer?
if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json")
    execute_process(
        COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
                ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()

# Whatever the platform, this always works.
find_package(
    Qt6
    COMPONENTS Widgets
               Core
               Gui
               PrintSupport
               Svg
               Xml
               Network
    REQUIRED
)

message("\n${BoldGreen}Now configuring library libXpertMassGui${ColourReset}\n")

########################################################
# Files
set(XpertMassGui_SRCS
    #
    # Utilities
    src/ColorSelector.cpp
    src/DecimalPlacesOptionsDlg.cpp
    src/ToleranceWidget.cpp
    src/ActionManager.cpp
    src/ActionManagerTableWidget.cpp
    #
    # Scripting
    src/JavaScriptingEnvironment.cpp
    src/JavaScriptingGuiUtils.cpp
    src/JavaScriptingWnd.cpp
    src/JavaScriptWorker.cpp
    src/ScriptingHistoryListWidget.cpp
    src/ScriptingObjectTreeWidgetItem.cpp
    src/JavaScriptQObjectExposureRecord.cpp
    src/JavaScriptQObjectExposureRegistry.cpp
    src/XpertMassGuiJavaScript.cpp
    #
    # Network
    src/MassDataClientServerConfigDlg.cpp
    #
    # Isotopic cluster and peak shaping
    src/IsotopicClusterGeneratorDlg.cpp
    src/IsotopicClusterShaperDlg.cpp
    src/IsotopicDataTableView.cpp
    src/IsotopicDataTableViewModel.cpp
    src/MassPeakShaperConfigDlg.cpp
    src/MassPeakShaperConfigWidget.cpp
    #
    # Labelled widget-based QAction classes
    src/LabelledDoubleSpinBoxAction.cpp
    src/LabelledNumberLineEditAction.cpp
    src/LabelledCheckBoxAction.cpp
)

set(XpertMassGui_UIS
    src/ui/DecimalPlacesOptionsDlg.ui
    src/ui/IsotopicClusterGeneratorDlg.ui
    src/ui/MassPeakShaperConfigDlg.ui
    src/ui/IsotopicClusterShaperDlg.ui
    src/ui/ElementGroupBoxWidget.ui
    src/ui/MassDataClientServerConfigDlg.ui
    src/ui/MassPeakShaperConfigWidget.ui
    src/ui/ToleranceWidget.ui
    src/ui/JavaScriptingWnd.ui
)

qt6_wrap_ui(XpertMassGui_UIS_H ${XpertMassGui_UIS})

qt6_add_resources(XpertMassGui_QRC_CPP xpertmassgui_resources.qrc)

# Because the header files are in their own directory and not along the source
# files, we need to have them listed explicitely for automoc to work properly
# below.

# Create a variable to hold the 'includes' directory *relative* to the
# current CMakeLists.txt file.

set(INCLUDES_DIR "${CMAKE_CURRENT_LIST_DIR}/includes")
file(GLOB_RECURSE XpertMassGui_HEADERS ${INCLUDES_DIR}/*.h ${INCLUDES_DIR}/*.hpp)
message(STATUS "Included the header files from ${INCLUDES_DIR}: \n\
  ${XpertMassGui_HEADERS}"
)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the library, because we have defined the sources.

#############################################################
# Build the static lib
add_library(
    Gui_static STATIC
    ${XpertMassGui_HEADERS}
    ${XpertMassGui_SRCS}
    ${XpertMassGui_UIS_H}
    ${XpertMassGui_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
)

set_target_properties(
    Gui_static
    PROPERTIES # Set target properties for namespace
               EXPORT_NAME "Gui_static"
               OUTPUT_NAME XpertMassGui
               LINK_FLAGS "-Wl,--whole-archive"
)

target_link_libraries(
    Gui_static
    PUBLIC PappsoMSpp::Core
           PappsoMSpp::Gui
           IsoSpec++::IsoSpec++
           Qt6::Core
           Qt6::Gui
           Qt6::Widgets
           Qt6::PrintSupport
           Qt6::Svg
           Qt6::Xml
           Qt6::Network
           QScintilla::QScintilla
           Qt6::Qml
           Core_static
)

if(PROFILING)
    target_link_options(Gui_static PRIVATE -pg)
endif()
# The INSTALL_INTERFACE that is ${prefix}/include

target_include_directories(
    Gui_static
    PUBLIC # These include directories are for building of this lib.
           $<BUILD_INTERFACE:${INCLUDES_DIR}>
           $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
           $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/source/XpertMass/includes>
           # These include directories are for users of this lib.
           $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

get_target_property(Gui_static_INCLUDES Gui_static INCLUDE_DIRECTORIES)
message(STATUS "Gui_static_INCLUDES: ${Gui_static_INCLUDES}")

install(
    TARGETS Gui_static
    EXPORT XpertMassGuiStaticTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    INCLUDES
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

# Export static targets
install(
    EXPORT XpertMassGuiStaticTargets
    FILE XpertMassGuiStaticTargets.cmake
    NAMESPACE XpertMass::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass
)

export(
    EXPORT XpertMassGuiStaticTargets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/XpertMassGuiStaticTargets.cmake"
    NAMESPACE XpertMass::
)

#############################################################
# Build the shared lib
add_library(
    Gui SHARED
    ${XpertMassGui_HEADERS}
    ${XpertMassGui_SRCS}
    ${XpertMassGui_UIS_H}
    ${XpertMassGui_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
)

set_target_properties(
    Gui
    PROPERTIES # Set target properties for namespace
               EXPORT_NAME "Gui"
               OUTPUT_NAME XpertMassGui
               VERSION ${PROJECT_VERSION}
               SOVERSION ${PROJECT_VERSION_MAJOR}
               LINK_FLAGS "-Wl,--no-as-needed"
               POSITION_INDEPENDENT_CODE ON
)

target_link_libraries(
    Gui
    PUBLIC PappsoMSpp::Core
           PappsoMSpp::Gui
           IsoSpec++::IsoSpec++
           Qt6::Core
           Qt6::Gui
           Qt6::Widgets
           Qt6::PrintSupport
           Qt6::Svg
           Qt6::Xml
           Qt6::Network
           QScintilla::QScintilla
           Qt6::Qml
           Core
)

if(PROFILING)
    target_link_options(Gui PRIVATE -pg)
endif()

# The install interface that is ${prefix}/include

target_include_directories(
    Gui
    PUBLIC # These include directories are for building of this lib.
           $<BUILD_INTERFACE:${INCLUDES_DIR}>
           $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
           $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/XpertMass/includes>
           # These include directories are for users of this lib.
           $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

get_target_property(Gui_INCLUDES Gui INCLUDE_DIRECTORIES)

message(STATUS "Gui_INCLUDES: ${Gui_INCLUDES}")

target_compile_definitions(Gui PRIVATE "EXPORT_LIB_SYMBOLS")

# This is to avoid the "include_next(math.h) file not found" error.
if(WIN32)
    set_target_properties(Gui_static PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)
    set_target_properties(Gui PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)
endif()

install(
    TARGETS Gui
    EXPORT XpertMassGuiSharedTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    INCLUDES
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

# Export shared targets
install(
    EXPORT XpertMassGuiSharedTargets
    FILE XpertMassGuiSharedTargets.cmake
    NAMESPACE XpertMass::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass
)

export(
    EXPORT XpertMassGuiSharedTargets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/XpertMassGuiSharedTargets.cmake"
    NAMESPACE XpertMass::
)

#############################################################
# Common installation configuration

message("The directory containing the includes: ${CMAKE_CURRENT_LIST_DIR}/includes/MsXpS/libXpertMassGui")

install(
    DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/includes/MsXpS/libXpertMassGui
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/MsXpS"
)

message("")
message(STATUS "CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}")
message("")
message(STATUS "${BoldGreen}Finished configuration of libXpertMassGui.${ColourReset}")
message("")

=== debian/changelog ===
libxpertmass (1.7.1-1build1) resolute; urgency=medium

  * No-change rebuild for boost 1.90.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Feb 2026 12:30:08 +0100

libxpertmass (1.7.1-1) unstable; urgency=low

  * New release fixing glitches and adding new decimal places related
    code.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 12 Jan 2026 16:49:43 +0100

libxpertmass (1.7.0-1) unstable; urgency=low

  * New release implementing an action manager that manages QAction and
    shortcuts. ActionManager is successfully used in MineXpert.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 09 Jan 2026 17:20:20 +0100

libxpertmass (1.6.0-1) unstable; urgency=low

  * New release implementing 'Recent files...' concept for use in menus.

  * Minor improvements in the mass peak shaper code.

  * Depends on newer version of libpappsomspp.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 18 Dec 2025 19:02:08 +0100

libxpertmass (1.5.0-1) unstable; urgency=low

  * New release implementing fixed-mz-range bins for isotopic cluster
    calculations.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 05 Dec 2025 11:19:51 +0100

libxpertmass (1.4.2-1) unstable; urgency=low

  * New release due to upgrade of libpappsomspp version.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 29 Nov 2025 17:24:53 +0100

libxpertmass (1.4.1-1) unstable; urgency=low

  * New upstream release fixing one bug in the initialization of an Ionizer
    using another Ionizer.
  * Improvements to the GCOV-based code coverage.
  * All tests pass.
  * Update Build-Depends for libpappsomspp.
  * Update Build-Depends for libisospec++.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 03 Nov 2025 21:50:05 +0100

## libxpertmass 1.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 project(
     XpertMass
-    VERSION 1.7.1
+    VERSION 1.8.1
     DESCRIPTION "Libraries [XpertMass::Core (non-GUI) and XpertMass::Gui) for the MsXpertSuite project."
     HOMEPAGE_URL "http://wwww.msxpertsuite.org/libxpertmass"
     LANGUAGES CXX

=== source/XpertMassCore/CMakeLists.txt ===
--- 
+++ 
@@ -94,6 +94,9 @@
     # Scripting-related
     src/XpertMassCoreJavaScript.cpp
     src/jsclassregistrar.cpp
+    #
+    # Deconvolution of mass spectra
+    src/LowMassDeconvolver.cpp
 )
 
 qt6_add_resources(XpertMassCore_QRC_CPP xpertmasscore_resources.qrc)

=== debian/changelog ===
libxpertmass (1.8.1-1) unstable; urgency=low

  * New release with new code implementing a low mass deconvolution algorithm.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 17 Feb 2026 15:24:07 +0100

=== debian/control ===
Source: libxpertmass
Section: libs
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-exec,
 d-shlibs,
 libxkbcommon-x11-dev,
 qt6-base-dev,
 qt6-declarative-dev,
 libqt6core5compat6-dev,
 libqcustomplot-dev (>= 2.1.0),
 libqscintilla2-qt6-dev,
 libqt6svg6-dev,
 qt6-documentation-tools,
 qt6-base-doc-html,
 libisospec++-dev (>=2.3.2),
 libsqlite3-dev,
 libzstd-dev,
 liblzf-dev,
 zlib1g-dev,
 libquazip1-qt6-dev,
 libpwizlite-dev(>= 3.0.11),
 libodsstream-dev (>= 0.9.15),
# Only the logically essential one.
 libpappsomspp-gui-dev (>= 0.11.9),
 libboost1.88-dev,
 libboost-thread1.88-dev,
 libboost-system1.88-dev,
 libboost-filesystem1.88-dev,
 libboost-iostreams1.88-dev,
 libboost-chrono1.88-dev,
 libboost-random1.88-dev,
 libboost-container1.88-dev,
 catch2
Standards-Version: 4.7.2
Homepage: http://www.msxpertsuite.org/xpertmass/
Vcs-Browser: https://salsa.debian.org/debichem-team/libxpertmass
Vcs-Git: https://salsa.debian.org/debichem-team/libxpertmass.git


Package: libxpertmasscore1
Architecture: any
Multi-Arch: same
Conflicts: libxpertmass1
Replaces: libxpertmass1
Breaks: libxpertmass1
Depends:
        ${shlibs:Depends},
        ${misc:Depends}
Description: C++ mass spectrometry libraries (non-GUI runtime files)
 The libXpertMassCore and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * MsXpertSuite/MassXpert3;
  * MsXpertSuite/MineXpert3
 .
 libXpertMassCore contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and MineXpert3.
 .
 This package ships the runtime files for the libXpertMassCore library.


Package: libxpertmasscore-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libxpertmass-dev
Replaces: libxpertmass-dev
Depends:
        libxpertmasscore1 (= ${binary:Version}),
        ${misc:Depends}
Recommends: libxpertmass-doc
Description: C++ mass spectrometry libraries (non-GUI development files)
 The libXpertMassCore and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * MsXpertSuite/MassXpert3;
  * MsXpertSuite/MineXpert3
 .
 libXpertMassCore contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and MineXpert3.
 .
 This package ships the development files for the libXpertMassCore library.


Package: libxpertmassgui1
Architecture: any
Multi-Arch: same
Conflicts: libxpertmassgui1
Replaces: libxpertmassgui1 (<< ${binary:Version})
Depends: libxpertmasscore1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: C++ mass spectrometry libraries (GUI runtime files)
 The libXpertMassCore and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * MsXpertSuite/MassXpert3;
  * MsXpertSuite/MineXpert3
 .
 libXpertMassCore contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and MineXpert3.
 .
 This package ships the runtime files for the libXpertMassGui library.


Package: libxpertmassgui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
        libxpertmasscore-dev (= ${binary:Version}),
        libxpertmassgui1 (= ${binary:Version}),
        ${misc:Depends}
Recommends: libxpertmass-doc
Description: C++ mass spectrometry libraries (GUI development files)
 The libXpertMassCore and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * MsXpertSuite/MassXpert3;
  * MsXpertSuite/MineXpert3
 .
 libXpertMassCore contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and MineXpert3.
 .
 This package ships the development files for the libXpertMassGui library.


Package: libxpertmass-doc
Section: doc
Architecture: all
Depends:
        ${misc:Depends}
Description: C++ mass spectrometry libraries (documentation files)
 The libXpertMassCore and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * MsXpertSuite/MassXpert3;
  * MsXpertSuite/MineXpert3
 .
 libXpertMassCore contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and MineXpert3,
  * write JavaScript (ECMAscript) code to automate a large number of
    functions.
 .
 This package ships the developer documentation for the two libraries.
